<?php
class grouk extends control {
  public function index() {
    if($this->config->grouk) {
      $groukConfig = $this->config->grouk;
      $groukConfig->turnon = $this->config->grouk->turnon;
      $groukConfig->webhook = $this->config->grouk->webhook;
    }

    $this->view->title = $this->lang->grouk->common . $this->lang->colon . $this->lang->grouk->edit;
    $this->view->position[] = html::a(inlink('index'), $this->lang->grouk->common);
    $this->view->position[] = $this->lang->grouk->index;

    $this->view->groukConfig = $groukConfig;
    $this->display();
  }

  public function save() {
    if(!empty($_POST)) {
      $groukConfig = new stdclass();

      $groukConfig->turnon = $this->post->turnon;
      $groukConfig->webhook = trim($this->post->webhook);

      $this->loadModel('setting')->setItems('system.grouk', $groukConfig);
      if(dao::isError()) {
        die(js::error(dao::getError()));
      }

      $this->session->set('groukConfig', '');

      $this->view->title = $this->lang->grouk->common . $this->lang->colon . $this->lang->grouk->save;
      $this->view->position[] = html::a(inlink('index'), $this->lang->grouk->common);
      $this->view->position[] = $this->lang->grouk->save;

      $this->display();
    }
  }

  public function reset() {
    $this->dao->delete('*')->from(TABLE_CONFIG)->where('module')->eq('grouk')->exec();
    $this->locate(inlink('index'));
  }

  public function test() {
    // if (!empty($_POST)) {
    //   $turnon = $this->post->turnon;
    //   $webhook = trim($this->post->webhook);
    //}
    $groukConfig = $this->grouk->getConfig();
    $webhook = trim($groukConfig->webhook);
    if (empty($webhook)) {
      $this->view->result = $this->lang->grouk->faileTest;
    }

    if (stripos($webhook, "http://") === false && stripos($webhook, "https://") === false) {
      $this->view->result = $this->lang->grouk->invalidWebhookURL;
    }

    $this->view->result = $this->lang->grouk->successTest;
    $result = $this->grouk->notified($webhook, 'this message from 禅道(zentao)');
    if($result != 200) {
      $this->view->result = $this->lang->grouk->faileTest;
    }

    $this->view->title = $this->lang->grouk->common . $this->lang->colon . $this->lang->grouk->test;
    $this->view->position[] = html::a(inlink('index'), $this->lang->grouk->common);
    $this->view->position[] = $this->lang->grouk->test;
    $this->display();
  }
}
