<?php
class groukModel extends model {
  public function getConfig() {
    $records = $this->dao->select('*')->from(TABLE_CONFIG)->where('module')->eq('grouk')->fetchAll();
    if(!$records) {
      return;
    }

    $config = new stdclass();
    foreach($records as $record) {
      if($record->key == 'webhook') {
        $config->webhook = $record->value;
      }
      if($record->key == 'turnon') {
        $config->turnon = $record->value;
      }
    }
    return $config;
  }

  public function notified($webhook, $message) {
    $charset = 'UTF-8';

    $ssl = substr($webhook, 0, 8) == "https://" ? true : false;

    $str = iconv($charset,'UTF-8',$message);
    $data = json_encode(array('text' => $str));

    $ch = curl_init();
    //增加证书验证属性
    if ($ssl) {
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // 信任任何证书
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false); // 检查证书中是否设置域名
    }
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_VERBOSE, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_URL, $webhook);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json; charset=utf-8', 'Content-Length: '.strlen($data)));
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    $response = curl_exec($ch);
    //print('request url: ' . $webhook . ', response: ' . $response);

    $code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);
    if($code == 200) {
      $resp = json_decode($response);
      if($resp->code == 0) {
        return 200;
      }
      return 500;
    }
    return $code;
  }

}
